//Класс для создания элементов формы в ExtJs 4 
//Версия 0.0.9

//Создание текстового поля с меткой сверху
function CreateTextFieldLabelTop(Title,Width,Value)
{
    Title = Title ? Title :'Текст';
    Width = Width ? Width :200;
    Value = Value ? Value :'';
    
    Item=Ext.create('Ext.form.field.Text', 
                    {
                        fieldLabel: Title,
                        labelAlign: 'top',
                        width:Width+'px',
                        inputWidth:Width,
                        value:Value
                    })
    return Item;
}

//Создание текстового поля с меткой сверху только чтение
function CreateTextFieldLabelTopReadOnly(Title,Width,Value)
{
    Title = Title ? Title :'Текст';
    Width = Width ? Width :200;
    Value = Value ? Value :0;
    
    Item=Ext.create('Ext.form.field.Text', 
                    {
                        fieldLabel: Title,
                        labelAlign:'top',
                        width:Width+'px',
                        readOnly:true,
                        inputWidth:Width,  
                        value:Value
                    })
    return Item;     
}


function CreateDateFieldLabelTop(Title,Width,Value,Format)
{
    Title = Title ? Title :'Дата';
    Width = Width ? Width :200;
    Value = Value ? Value :new Date();
    Format = Format ? Format :'Y-m-d';
    
    Item=Ext.create('Ext.form.field.Date', 
                    {
                         format: Format,
                         altFormats: Format,              
                         fieldLabel: Title,
                         labelAlign: 'top',
						 startDay: 1,
                        // style:{margin:'5px 10px 0 5px'},
                         width: Width, 
                         value: Value
                    })
    return Item;     
}

//Создание числового поля с меткой сверху
function CreateNumberFieldLabelTop(Title,Width,Value,minValue,maxValue,step)
{
    Title = Title ? Title :'Число';
    Width = Width ? Width :200;
    Value = Value ? Value :0;
    minValue = minValue ? minValue :0;
    maxValue = maxValue ? maxValue :100;
    step = step ? step :1;
    
    Item=Ext.create('Ext.form.field.Number', 
                    {
                        fieldLabel: Title,
                        labelAlign: 'top',
                        minValue: minValue,
                        maxValue: maxValue,
                        step: step,
                        width:Width,
                        value:Value
                    })
    return Item;     
}

//Создание кнопки с подсказкой на кнопке текст
function CreateButtonTooltipText(Title,ToolTipText)
{
    Title = Title ? Title :'Кнопка';
    ToolTipText = ToolTipText ? ToolTipText :'';
    
    Item=Ext.create('Ext.button.Button', 
                    {
                        text : Title,
                        tooltip : ToolTipText,
                        pressed: true,
                    })
    return Item;     
}

//Создание кнопки с подсказкой на кнопке изображение
function CreateButtonTooltipIcon(IconSRC,ToolTipText,Scale)
{
    IconSRC = IconSRC ? IconSRC :'';
    ToolTipText = ToolTipText ? ToolTipText :'';
    Scale = Scale ? Scale :'medium';
    
    Item=Ext.create('Ext.button.Button', 
                    {
                        icon : IconSRC,
                        scale : Scale,
                        ClickedButton: 0,
                        tooltip : ToolTipText 
                    })
    return Item;     
}

//Создание выпадающего списка с меткой сверху модель локальная
function CreateComboboxFieldLabelTopLocal(Title,Store,DisplayField,ValueField,Width,Value)
{
    Width = Width ? Width :300;
    Value = Value ? Value :'';
    
    Item=Ext.create('Ext.form.field.ComboBox', 
                    {            
                        fieldLabel:Title,
                        labelAlign: 'top',
                        width:Width,
                        store:Store,
                        queryMode: 'local',
                        displayField:DisplayField,
                        valueField: ValueField,
                        value:Value   
                    })
    return Item;     
}

function CreateDisplayField(Value)
{
    Value = Value ? Value :'Текст';
    
    Item=Ext.create('Ext.form.field.Display', 
                    {
                       // style:{margin:'5px 10px 0 5px'},          
                        value:Value
                    })
    return Item;    
}

//Создание панели с позиционированием по регионам, может схлопываться
function CreatePanelRegionCollaps(Title,Region,Heigth) 
{
    Heigth = Heigth ? Heigth :300;
    Title = Title ? Title :'Панель';
    
    Item=Ext.create('Ext.panel.Panel', 
                    {            
                        region: Region,
                        collapsible: true, 
                        title: Title,
                        maxHeight:Heigth 
                    })
    return Item;     
}

//Создание панели Google Maps
function CreatePanelGoogleMaps(ZoomLevel,Latitude,Longitude,Padding) 
{
    ZoomLevel = ZoomLevel ? ZoomLevel :11;
    Padding = Padding ? Padding :0;
    Latitude = Latitude ? Latitude :50.5;
    Longitude = Longitude ? Longitude :30.5;
    
    Item=Ext.create('Ext.ux.GMapPanel', 
                    {            
                        zoomLevel:ZoomLevel,
                        gmapType: 'map',
                        padding: Padding, 
                        mapConfOpts: ['enableScrollWheelZoom','enableDoubleClickZoom','enableDragging'],
                        setCenter: 
                        {
                            lat:Latitude,
                            lng:Longitude
                        }
                    })
    return Item;     
}

function CreateSliderTips(Width,TipsDescr,MinValue,MaxValue)
{
     Width = Width ? Width : 200;
     MinValue = MinValue ? MinValue : 0;
     MaxValue = MaxValue ? MaxValue : 0; 
     TipsDescr = TipsDescr ? TipsDescr : '';
     
     Item=Ext.create('Ext.slider.Single', 
                    {            
                         width: Width,
                         minValue: MinValue,
                         maxValue: MaxValue,
                         useTips: true,
                         tipText: function(thumb)
                         {
                            return Ext.String.format('{0} '+TipsDescr, thumb.value);
                         }
                    })
    return Item;
}

function CreateCheckBox(Title,Value,Checek)
{
     Title = Title ? Title : 'Чекбокс';
     Value = Value ? Value : 0;
     Checek= Checek ? Checek: false; 

     Item=Ext.create('Ext.form.field.Checkbox', 
                    {
                         boxLabel   : Title,
                         inputValue : Value,
                         checked    : Checek
                                     
                    })
    return Item;
}

/*function CreateDisplayField(Title,Width,Value)
{
    Title = Title ? Title :'Текст';
    Width = Width ? Width :200;
    Value = Value ? Value :'0';
    
    Item=Ext.create('Ext.form.field.Display', 
                    {
                        fieldLabel: Title,
                        width:Width+'px',
                        labelWidth:Width,
                        inputWidth:Width,   
                        value:Value
                    })
    return Item;     
}*/



function Forms()
{
    this.CreateTextFieldLabelTop=CreateTextFieldLabelTop;
    this.CreateTextFieldLabelTopReadOnly=CreateTextFieldLabelTopReadOnly;
    this.CreateDateFieldLabelTop=CreateDateFieldLabelTop;
    this.CreateNumberFieldLabelTop=CreateNumberFieldLabelTop;
    this.CreateButtonTooltipIcon=CreateButtonTooltipIcon;
    this.CreateButtonTooltipText=CreateButtonTooltipText;
    this.CreateComboboxFieldLabelTopLocal=CreateComboboxFieldLabelTopLocal;
    this.CreatePanelRegionCollaps=CreatePanelRegionCollaps;
    this.CreatePanelGoogleMaps=CreatePanelGoogleMaps;
    this.CreateSliderTips=CreateSliderTips;
   // this.CreateDisplayField=CreateDisplayField;
    this.CreateCheckBox=CreateCheckBox;
    this.CreateDisplayField=CreateDisplayField;
}